#!/usr/bin/env -S python3 -B
#
#    gridsquares.py
#
#    Call validator using simple patterns.
#
#    Copyright (C) 2024 by Matt Roberts.
#    License: GNU GPL3 (www.gnu.org)
#
#

patterns = [
	'aann',
	'aannaa',
	'aannaann',
	'aannaannaa',
	'aannaannaann',
]


#
#  isgrid(s) - return True iff string is a maidenhead grid square
#
def isgrid(s):
	global patterns
	A = ord('A')
	R = ord('R')
	pattern = [ ]
	for i in s:
		if i.isalpha():
			ch = ord(i.upper())
			if ch >= A and ch <= R:
				pattern.append('a')
		elif i.isdigit():
			pattern.append('n')
		else:
			pattern.append('.')
	return ''.join(pattern) in patterns



#
#  entry point - unit tests
#
if __name__ == '__main__':
	teststrings = [
		"EM16",
		"EM16L",
		"EM16LC",
		"RR73",
		"RS73",
		"RS73f",
		"E116",
		"EML6",
		"ZZ99",
	]

	for s in teststrings:
		print("isgrid(%s) => %s" % (s, isgrid(s)))

# EOF
